// C Source File
// Created 03/02/2002; 17:15:41
void *lcd0,*lcd1;

#define OPTIMIZE_ROM_CALLS

#define USE_TI89              // Produce .89z File

#define SAVE_SCREEN           // Save/Restore LCD Contents

#define RETURN_VALUE

#define KEYFLAGS_ESC     1
#define KEYFLAGS_UP      2
#define KEYFLAGS_DOWN    4
#define KEYFLAGS_LEFT    8
#define KEYFLAGS_RIGHT  16
#define KEYFLAGS_2ND    32
#define KEYFLAGS_DIAM   64

#include "gray.h"
#include "raycasting.h"
#include <estack.h>
#include <kbd.h>
#include <intr.h>


unsigned char GetKeys89(void) {
    unsigned char key = 0;
    if (_rowread(~(1<<6)) & 0x01) key |= KEYFLAGS_ESC;
    if (_rowread(~(1<<0)) & 0x01) key |= KEYFLAGS_UP;
    if (_rowread(~(1<<0)) & 0x02) key |= KEYFLAGS_LEFT;
    if (_rowread(~(1<<0)) & 0x04) key |= KEYFLAGS_DOWN;
    if (_rowread(~(1<<0)) & 0x08) key |= KEYFLAGS_RIGHT;
    if (_rowread(~(1<<0)) & 0x10) key |= KEYFLAGS_2ND;
    if (_rowread(~(1<<0)) & 0x40) key |= KEYFLAGS_DIAM;
    return key;
}


// Main Function
void _main(void)
{
unsigned long frame=0;
unsigned char key;
signed short angle;
unsigned long px,py;
INT_HANDLER toldint; 	
	
  alloc();
	centeradd=1080+backbuf;
	centeradd2=1080+backbuf2;
	center=36;
	toldint=GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	GrayMode(GRAY_ON);
	lcd0=GetPlane(LIGHT_PLANE);
	lcd1=GetPlane(DARK_PLANE);
	key=0;
	angle=angle_270;
	px=150000;
	py=90000;
	ClearScreen();
	clear();
	render(angle,px,py);
	frame++;
	while (!(key & KEYFLAGS_ESC)){
  key=GetKeys89();
  if (key & KEYFLAGS_RIGHT){
  	 angle-=8;
	if (angle<0) angle+=720;
	}
	if (key & KEYFLAGS_LEFT){
		  angle+=8;
		  if (angle>=720) angle-=720;
	}
	if (key & KEYFLAGS_UP){
		if (!tableau[py>>16][(px+cosin[angle])>>16]) px+=cosin[angle];
		if (!tableau[(py-sinu[angle])>>16][px>>16]) py-=sinu[angle];
	}
	if (key & KEYFLAGS_DOWN){
		if (!tableau[py>>16][(px-cosin[angle])>>16]) px-=cosin[angle];
		if (!tableau[(py+sinu[angle])>>16][px>>16]) py+=sinu[angle];
	}
	if (key & KEYFLAGS_2ND){
		if (center<68) center+=3;
		centeradd=backbuf+((center<<5)-(center<<1));
    centeradd2=backbuf2+((center<<5)-(center<<1));	
	}
	if (key & KEYFLAGS_DIAM){
		if (center>4) center-=3;
		centeradd=backbuf+((center<<5)-(center<<1));
		centeradd2=backbuf2+((center<<5)-(center<<1));
	}
	 clear();
	 render(angle,px,py);
	 frame++;
	}
	GrayMode(GRAY_OFF);
	SetIntVec(AUTO_INT_1,toldint);
	free(backbuf);
	free(backbuf2);
	push_longint(frame);
}
